package ru.landgrafhomyak.db.serdha0.user_commons.reducers

import ru.landgrafhomyak.db.serdha0.api.misc.DatabaseType
import ru.landgrafhomyak.db.serdha0.api.misc.Reducer
import ru.landgrafhomyak.db.serdha0.api.runtime.InputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow

public class HasRows private constructor(context: Reducer.Constructor.Scope<HasRows>) : Reducer.Action<HasRows> {
	@Suppress("PropertyName", "MemberVisibilityCanBePrivate")
	public val C_HasRows: Reducer.OutputColumn<Boolean, DatabaseType.BOOLEAN, HasRows> =
		context.outputColumn("flag", context.types.BOOLEAN, false)

	override fun calculate(acc: OutputRow<HasRows>, row: OutputRow<HasRows>, newAcc: InputRow<HasRows>) {
		newAcc[this.C_HasRows] = true
	}

	public object Constructor : Reducer.Constructor<HasRows> {
		override fun createReducer(context: Reducer.Constructor.Scope<HasRows>): Reducer.Action<HasRows> =
			HasRows(context)
	}
}